Index: doc/coding_style.dox
===================================================================
--- doc/coding_style.dox	(revision 921)
+++ doc/coding_style.dox	(revision 955)
@@ -12,7 +12,33 @@
 developing LEMON library.
 
+\warning In some cases we diverge from these rules.
+This primary done because STL uses different naming convention and
+in certain cases
+it is beneficial to provide STL compatible interface.
+
+\subsection cs-files File Names
+
+The header file names should look like the following.
+
+\code
+header_file.h
+\endcode
+
+Note that all standard Lemon headers are located in the \c lemon subdirectory,
+so you should include them from C++ source like this:
+
+\code
+#include <lemon/header_file.h>
+\endcode
+
+The source code files use the same style and they have '.cc' extension.
+
+\code
+source_code.cc
+\endcode
+
 \subsection cs-class Classes and other types
 
-The name of a class or any type should look like the following:
+The name of a class or any type should look like the following.
 
 \code
@@ -22,5 +48,5 @@
 \subsection cs-func Methods and other functions
 
-The name of a function should look like the following:
+The name of a function should look like the following.
 
 \code
@@ -30,5 +56,5 @@
 \subsection cs-funcs Constants, Macros
 
-The names of constants and macros should look like the following:
+The names of constants and macros should look like the following.
 
 \code
@@ -38,5 +64,5 @@
 \subsection cs-loc-var Class and instance member variables, auto variables 
 
-The names of class and instance member variables and auto variables (=variables used locally in methods) should look like the following:
+The names of class and instance member variables and auto variables (=variables used locally in methods) should look like the following.
 
 \code
@@ -46,5 +72,5 @@
 \subsection cs-excep Exceptions
 
-When writing exceptions please comply the following naming conventions:
+When writing exceptions please comply the following naming conventions.
 
 \code
@@ -52,8 +78,3 @@
 \endcode
 
-\warning In some cases we diverge from these rules.
-This primary done because STL uses different naming convention and
-in certain cases
-it is beneficial to provide STL compatible interface.
-
 */
Index: doc/named-param.dox
===================================================================
--- doc/named-param.dox	(revision 954)
+++ doc/named-param.dox	(revision 955)
@@ -3,5 +3,10 @@
 \page named-param Named Parameters
 
-\section named-templ-param Named Template Parameters
+\section named-func-param Named "Function" Parameters
+
+
+\section traits-classes Traits Classes
+
+\section named-templ-param Named Class Template Parameters
 
 Instead of creating a new traits class you can also use this adaptor class
@@ -16,4 +21,6 @@
 \endcode
 
+\section named-templ-func-param Named "Function" Template Parameters
+
 
 */
Index: src/work/alpar/dijkstra.h
===================================================================
--- src/work/alpar/dijkstra.h	(revision 954)
+++ src/work/alpar/dijkstra.h	(revision 955)
@@ -110,5 +110,5 @@
   ///
   ///\param GR The graph type the algorithm runs on. The default value is
-  ///\ref ListGraph. The value of GR is not used directly by %Dijsktra, it
+  ///\ref ListGraph. The value of GR is not used directly by Dijkstra, it
   ///is only passed to \ref DijkstraDefaultTraits.
   ///\param LM This read-only
@@ -119,9 +119,9 @@
   ///length if it is necessary. The default map type is
   ///\ref skeleton::StaticGraph::EdgeMap "Graph::EdgeMap<int>".
-  ///The value of LM is not used directly by %Dijsktra, it
+  ///The value of LM is not used directly by Dijkstra, it
   ///is only passed to \ref DijkstraDefaultTraits.
   ///\param TR Traits class to set various data types used by the algorithm.
   ///The default traits class is
-  ///\ref DijkstraDefaultTraits<GR,LM> "DijkstraDefaultTraits<GR,LM>".
+  ///\ref DijkstraDefaultTraits "DijkstraDefaultTraits<GR,LM>".
   ///See \ref DijkstraDefaultTraits for the documentation of
   ///a Dijkstra traits class.