Index: test/maps_test.cc
===================================================================
--- test/maps_test.cc	(revision 836)
+++ test/maps_test.cc	(revision 956)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2009
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -226,5 +226,6 @@
 
     checkConcept<ReadMap<A,B>, MapToFunctor<ReadMap<A,B> > >();
-    MapToFunctor<ReadMap<A,B> > map = MapToFunctor<ReadMap<A,B> >(ReadMap<A,B>());
+    MapToFunctor<ReadMap<A,B> > map =
+      MapToFunctor<ReadMap<A,B> >(ReadMap<A,B>());
 
     check(functorToMap(&func)[A()] == 3,
@@ -378,5 +379,5 @@
           it != map2.end(); ++it )
       check(v1[i++] == *it, "Something is wrong with LoggerBoolMap");
-    
+
     typedef ListDigraph Graph;
     DIGRAPH_TYPEDEFS(Graph);
@@ -387,5 +388,5 @@
     Node n2 = gr.addNode();
     Node n3 = gr.addNode();
-    
+
     gr.addArc(n3, n0);
     gr.addArc(n3, n2);
@@ -393,5 +394,5 @@
     gr.addArc(n2, n1);
     gr.addArc(n0, n1);
-    
+
     {
       std::vector<Node> v;
@@ -404,10 +405,10 @@
       std::vector<Node> v(countNodes(gr));
       dfs(gr).processedMap(loggerBoolMap(v.begin())).run();
-      
+
       check(v.size()==4 && v[0]==n1 && v[1]==n2 && v[2]==n0 && v[3]==n3,
             "Something is wrong with LoggerBoolMap");
     }
   }
-  
+
   // IdMap, RangeIdMap
   {
@@ -419,5 +420,5 @@
     checkConcept<ReadMap<Node, int>, RangeIdMap<Graph, Node> >();
     checkConcept<ReadMap<Arc, int>, RangeIdMap<Graph, Arc> >();
-    
+
     Graph gr;
     IdMap<Graph, Node> nmap(gr);
@@ -425,14 +426,14 @@
     RangeIdMap<Graph, Node> nrmap(gr);
     RangeIdMap<Graph, Arc> armap(gr);
-    
+
     Node n0 = gr.addNode();
     Node n1 = gr.addNode();
     Node n2 = gr.addNode();
-    
+
     Arc a0 = gr.addArc(n0, n1);
     Arc a1 = gr.addArc(n0, n2);
     Arc a2 = gr.addArc(n2, n1);
     Arc a3 = gr.addArc(n2, n0);
-    
+
     check(nmap[n0] == gr.id(n0) && nmap(gr.id(n0)) == n0, "Wrong IdMap");
     check(nmap[n1] == gr.id(n1) && nmap(gr.id(n1)) == n1, "Wrong IdMap");
@@ -446,5 +447,5 @@
     check(nmap.inverse()[gr.id(n0)] == n0, "Wrong IdMap::InverseMap");
     check(amap.inverse()[gr.id(a0)] == a0, "Wrong IdMap::InverseMap");
-    
+
     check(nrmap.size() == 3 && armap.size() == 4,
           "Wrong RangeIdMap::size()");
@@ -453,5 +454,5 @@
     check(nrmap[n1] == 1 && nrmap(1) == n1, "Wrong RangeIdMap");
     check(nrmap[n2] == 2 && nrmap(2) == n2, "Wrong RangeIdMap");
-    
+
     check(armap[a0] == 0 && armap(0) == a0, "Wrong RangeIdMap");
     check(armap[a1] == 1 && armap(1) == a1, "Wrong RangeIdMap");
@@ -461,12 +462,12 @@
     check(nrmap.inverse()[0] == n0, "Wrong RangeIdMap::InverseMap");
     check(armap.inverse()[0] == a0, "Wrong RangeIdMap::InverseMap");
-    
+
     gr.erase(n1);
-    
+
     if (nrmap[n0] == 1) nrmap.swap(n0, n2);
     nrmap.swap(n2, n0);
     if (armap[a1] == 1) armap.swap(a1, a3);
     armap.swap(a3, a1);
-    
+
     check(nrmap.size() == 2 && armap.size() == 2,
           "Wrong RangeIdMap::size()");
@@ -474,5 +475,5 @@
     check(nrmap[n0] == 1 && nrmap(1) == n0, "Wrong RangeIdMap");
     check(nrmap[n2] == 0 && nrmap(0) == n2, "Wrong RangeIdMap");
-    
+
     check(armap[a1] == 1 && armap(1) == a1, "Wrong RangeIdMap");
     check(armap[a3] == 0 && armap(0) == a3, "Wrong RangeIdMap");
@@ -481,10 +482,10 @@
     check(armap.inverse()[0] == a3, "Wrong RangeIdMap::InverseMap");
   }
-  
+
   // SourceMap, TargetMap, ForwardMap, BackwardMap, InDegMap, OutDegMap
   {
     typedef ListGraph Graph;
     GRAPH_TYPEDEFS(Graph);
-    
+
     checkConcept<ReadMap<Arc, Node>, SourceMap<Graph> >();
     checkConcept<ReadMap<Arc, Node>, TargetMap<Graph> >();
@@ -498,5 +499,5 @@
     Node n1 = gr.addNode();
     Node n2 = gr.addNode();
-    
+
     gr.addEdge(n0,n1);
     gr.addEdge(n1,n2);
@@ -505,10 +506,10 @@
     gr.addEdge(n1,n2);
     gr.addEdge(n0,n1);
-    
+
     for (EdgeIt e(gr); e != INVALID; ++e) {
       check(forwardMap(gr)[e] == gr.direct(e, true), "Wrong ForwardMap");
       check(backwardMap(gr)[e] == gr.direct(e, false), "Wrong BackwardMap");
     }
-    
+
     check(mapCompare(gr,
           sourceMap(orienter(gr, constMap<Edge, bool>(true))),
@@ -520,8 +521,8 @@
     OutDegMap<Digraph> odm(dgr);
     InDegMap<Digraph> idm(dgr);
-    
+
     check(odm[n0] == 3 && odm[n1] == 2 && odm[n2] == 1, "Wrong OutDegMap");
     check(idm[n0] == 0 && idm[n1] == 3 && idm[n2] == 3, "Wrong InDegMap");
-   
+
     gr.addEdge(n2, n0);
 
@@ -529,5 +530,5 @@
     check(idm[n0] == 1 && idm[n1] == 3 && idm[n2] == 3, "Wrong InDegMap");
   }
-  
+
   // CrossRefMap
   {
@@ -541,17 +542,17 @@
     checkConcept<ReadWriteMap<Node, double>,
                  CrossRefMap<Graph, Node, double> >();
-    
+
     Graph gr;
     typedef CrossRefMap<Graph, Node, char> CRMap;
     CRMap map(gr);
-    
+
     Node n0 = gr.addNode();
     Node n1 = gr.addNode();
     Node n2 = gr.addNode();
-    
+
     map.set(n0, 'A');
     map.set(n1, 'B');
     map.set(n2, 'C');
-    
+
     check(map[n0] == 'A' && map('A') == n0 && map.inverse()['A'] == n0,
           "Wrong CrossRefMap");
@@ -562,9 +563,9 @@
     check(map.count('A') == 1 && map.count('B') == 1 && map.count('C') == 1,
           "Wrong CrossRefMap::count()");
-    
+
     CRMap::ValueIt it = map.beginValue();
     check(*it++ == 'A' && *it++ == 'B' && *it++ == 'C' &&
           it == map.endValue(), "Wrong value iterator");
-    
+
     map.set(n2, 'A');
 
@@ -604,14 +605,14 @@
     checkConcept<ReadWriteMap<Node, int>,
                  CrossRefMap<Graph, Node, int> >();
-    
+
     Graph gr;
     typedef CrossRefMap<Graph, Node, char> CRMap;
     typedef CRMap::ValueIterator ValueIt;
     CRMap map(gr);
-    
+
     Node n0 = gr.addNode();
     Node n1 = gr.addNode();
     Node n2 = gr.addNode();
-    
+
     map.set(n0, 'A');
     map.set(n1, 'B');
@@ -630,5 +631,5 @@
           it == map.endValue(), "Wrong value iterator");
   }
-  
+
   // Iterable bool map
   {
@@ -818,5 +819,5 @@
 
   }
-  
+
   // Graph map utilities:
   // mapMin(), mapMax(), mapMinValue(), mapMaxValue()
@@ -830,14 +831,14 @@
     Node n2 = g.addNode();
     Node n3 = g.addNode();
-    
+
     SmartDigraph::NodeMap<int> map1(g);
     SmartDigraph::ArcMap<char> map2(g);
     ConstMap<Node, A> cmap1 = A();
     ConstMap<Arc, C> cmap2 = C(0);
-    
+
     map1[n1] = 10;
     map1[n2] = 5;
     map1[n3] = 12;
-    
+
     // mapMin(), mapMax(), mapMinValue(), mapMaxValue()
     check(mapMin(g, map1) == n2, "Wrong mapMin()");
@@ -858,5 +859,5 @@
     Arc a3 = g.addArc(n2, n3);
     Arc a4 = g.addArc(n3, n1);
-    
+
     map2[a1] = 'b';
     map2[a2] = 'a';
@@ -925,5 +926,5 @@
     check(mapCountIf(g, map2, Less<char>('a')) == 0,
           "Wrong mapCountIf()");
-     
+
     // MapIt, ConstMapIt
 /*
@@ -935,5 +936,5 @@
     check(*std::max_element(ConstMapIt(map1), ConstMapIt(INVALID)) == 12,
           "Wrong NodeMap<>::MapIt");
-    
+
     int sum = 0;
     std::for_each(MapIt(map1), MapIt(INVALID), Sum<int>(sum));
@@ -952,23 +953,23 @@
     SmartDigraph::NodeMap<int> map3(g, 0);
     SmartDigraph::ArcMap<char> map4(g, 'a');
-    
+
     check(!mapCompare(g, map1, map3), "Wrong mapCompare()");
-    check(!mapCompare(g, map2, map4), "Wrong mapCompare()");    
-    
+    check(!mapCompare(g, map2, map4), "Wrong mapCompare()");
+
     mapCopy(g, map1, map3);
     mapCopy(g, map2, map4);
 
     check(mapCompare(g, map1, map3), "Wrong mapCompare() or mapCopy()");
-    check(mapCompare(g, map2, map4), "Wrong mapCompare() or mapCopy()");    
-    
+    check(mapCompare(g, map2, map4), "Wrong mapCompare() or mapCopy()");
+
     Undirector<SmartDigraph> ug(g);
     Undirector<SmartDigraph>::EdgeMap<char> umap1(ug, 'x');
     Undirector<SmartDigraph>::ArcMap<double> umap2(ug, 3.14);
-    
+
     check(!mapCompare(g, map2, umap1), "Wrong mapCompare() or mapCopy()");
     check(!mapCompare(g, umap1, map2), "Wrong mapCompare() or mapCopy()");
     check(!mapCompare(ug, map2, umap1), "Wrong mapCompare() or mapCopy()");
     check(!mapCompare(ug, umap1, map2), "Wrong mapCompare() or mapCopy()");
-    
+
     mapCopy(g, map2, umap1);
 
@@ -977,14 +978,14 @@
     check(mapCompare(ug, map2, umap1), "Wrong mapCompare() or mapCopy()");
     check(mapCompare(ug, umap1, map2), "Wrong mapCompare() or mapCopy()");
-    
+
     mapCopy(g, map2, umap1);
     mapCopy(g, umap1, map2);
     mapCopy(ug, map2, umap1);
     mapCopy(ug, umap1, map2);
-    
+
     check(!mapCompare(ug, umap1, umap2), "Wrong mapCompare() or mapCopy()");
     mapCopy(ug, umap1, umap2);
     check(mapCompare(ug, umap1, umap2), "Wrong mapCompare() or mapCopy()");
-    
+
     check(!mapCompare(g, map1, constMap<Node>(2)), "Wrong mapCompare()");
     mapFill(g, map1, 2);
@@ -995,5 +996,5 @@
     check(mapCompare(g, constMap<Arc>('z'), map2), "Wrong mapCopy()");
   }
-  
+
   return 0;
 }