Index: test/CMakeLists.txt
===================================================================
--- test/CMakeLists.txt	(revision 960)
+++ test/CMakeLists.txt	(revision 942)
@@ -14,5 +14,4 @@
 SET(TESTS
   adaptors_test
-  arc_look_up_test
   bellman_ford_test
   bfs_test
@@ -88,5 +87,5 @@
     GET_FILENAME_COMPONENT(TARGET_PATH ${TARGET_LOC} PATH)
     ADD_CUSTOM_COMMAND(TARGET lp_test POST_BUILD
-      COMMAND ${CMAKE_COMMAND} -E copy ${CPLEX_BIN_DIR}/cplex.dll ${TARGET_PATH}
+      COMMAND ${CMAKE_COMMAND} -E copy ${CPLEX_BIN_DIR}/cplex91.dll ${TARGET_PATH}
     )
   ENDIF()
@@ -130,5 +129,5 @@
     GET_FILENAME_COMPONENT(TARGET_PATH ${TARGET_LOC} PATH)
     ADD_CUSTOM_COMMAND(TARGET mip_test POST_BUILD
-      COMMAND ${CMAKE_COMMAND} -E copy ${CPLEX_BIN_DIR}/cplex.dll ${TARGET_PATH}
+      COMMAND ${CMAKE_COMMAND} -E copy ${CPLEX_BIN_DIR}/cplex91.dll ${TARGET_PATH}
     )
   ENDIF()
Index: test/Makefile.am
===================================================================
--- test/Makefile.am	(revision 944)
+++ test/Makefile.am	(revision 942)
@@ -79,7 +79,7 @@
 test_graph_test_SOURCES = test/graph_test.cc
 test_graph_utils_test_SOURCES = test/graph_utils_test.cc
-test_hao_orlin_test_SOURCES = test/hao_orlin_test.cc
 test_heap_test_SOURCES = test/heap_test.cc
 test_kruskal_test_SOURCES = test/kruskal_test.cc
+test_hao_orlin_test_SOURCES = test/hao_orlin_test.cc
 test_lgf_test_SOURCES = test/lgf_test.cc
 test_lp_test_SOURCES = test/lp_test.cc
Index: test/adaptors_test.cc
===================================================================
--- test/adaptors_test.cc	(revision 504)
+++ test/adaptors_test.cc	(revision 961)
@@ -1378,11 +1378,13 @@
 
   // Apply several adaptors on the grid graph
-  typedef SplitNodes<Orienter< const GridGraph, GridGraph::EdgeMap<bool> > >
-    SplitGridGraph;
+  typedef Orienter< const GridGraph, GridGraph::EdgeMap<bool> >
+    OrientedGridGraph;
+  typedef SplitNodes<OrientedGridGraph> SplitGridGraph;
   typedef Undirector<const SplitGridGraph> USplitGridGraph;
   checkConcept<concepts::Digraph, SplitGridGraph>();
   checkConcept<concepts::Graph, USplitGridGraph>();
 
-  SplitGridGraph adaptor = splitNodes(orienter(graph, dir_map));
+  OrientedGridGraph oadaptor = orienter(graph, dir_map);
+  SplitGridGraph adaptor = splitNodes(oadaptor);
   USplitGridGraph uadaptor = undirector(adaptor);
 
Index: test/arc_look_up_test.cc
===================================================================
--- test/arc_look_up_test.cc	(revision 959)
+++ 	(revision )
@@ -1,85 +1,0 @@
-/* -*- mode: C++; indent-tabs-mode: nil; -*-
- *
- * This file is a part of LEMON, a generic C++ optimization library.
- *
- * Copyright (C) 2003-2009
- * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
- * (Egervary Research Group on Combinatorial Optimization, EGRES).
- *
- * Permission to use, modify and distribute this software is granted
- * provided that this copyright notice appears in all copies. For
- * precise terms see the accompanying LICENSE file.
- *
- * This software is provided "AS IS" with no warranty of any kind,
- * express or implied, and with no claim as to its suitability for any
- * purpose.
- *
- */
-
-#include <iostream>
-#include "lemon/list_graph.h"
-#include "lemon/lgf_reader.h"
-
-#include "test_tools.h"
-
-using namespace lemon;
-
-const int lgfn = 4;
-const std::string lgf =
-  "@nodes\n"
-"label\n"
-"0\n"
-"1\n"
-"2\n"
-"3\n"
-"4\n"
-"5\n"
-"6\n"
-"@arcs\n"
-"label\n"
-"5 6 0\n"
-"5 4 1\n"
-"4 6 2\n"
-"3 4 3\n"
-"3 4 4\n"
-"3 2 5\n"
-"3 5 6\n"
-"3 5 7\n"
-"3 5 8\n"
-"3 5 9\n"
-"2 4 10\n"
-"2 4 11\n"
-"2 4 12\n"
-"2 4 13\n"
-"1 2 14\n"
-"1 2 15\n"
-"1 0 16\n"
-"1 3 17\n"
-"1 3 18\n"
-"1 3 19\n"
-"1 3 20\n"
-"0 2 21\n"
-"0 2 22\n"
-"0 2 23\n"
-"0 2 24\n";
-
-
-int main() {
-  ListDigraph graph;
-  std::istringstream lgfs(lgf);
-  DigraphReader<ListDigraph>(graph, lgfs).run();
-  
-  AllArcLookUp<ListDigraph> lookup(graph);
-	
-  int numArcs = countArcs(graph);
-	
-  int arcCnt = 0;
-  for(ListDigraph::NodeIt n1(graph); n1 != INVALID; ++n1)
-    for(ListDigraph::NodeIt n2(graph); n2 != INVALID; ++n2)
-      for(ListDigraph::Arc a = lookup(n1, n2); a != INVALID;
-	  a = lookup(n1, n2, a))
-	++arcCnt;
-  check(arcCnt==numArcs, "Wrong total number of arcs");
-
-  return 0;
-}
Index: test/dfs_test.cc
===================================================================
--- test/dfs_test.cc	(revision 944)
+++ test/dfs_test.cc	(revision 942)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2011
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -220,5 +220,5 @@
   check(dfs.run(s1,t1) && dfs.reached(t1),"Node 3 is reachable from Node 6.");
   }
-
+  
   {
     NullMap<Node,Arc> myPredMap;
Index: test/graph_copy_test.cc
===================================================================
--- test/graph_copy_test.cc	(revision 927)
+++ test/graph_copy_test.cc	(revision 896)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2011
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -71,5 +71,5 @@
     nodeCrossRef(ncr).arcCrossRef(ecr).
     node(fn, tn).arc(fa, ta).run();
-
+  
   check(countNodes(from) == countNodes(to), "Wrong copy.");
   check(countArcs(from) == countArcs(to), "Wrong copy.");
@@ -99,5 +99,5 @@
   // Test repeated copy
   digraphCopy(from, to).run();
-
+  
   check(countNodes(from) == countNodes(to), "Wrong copy.");
   check(countArcs(from) == countArcs(to), "Wrong copy.");
@@ -201,5 +201,5 @@
   // Test repeated copy
   graphCopy(from, to).run();
-
+  
   check(countNodes(from) == countNodes(to), "Wrong copy.");
   check(countEdges(from) == countEdges(to), "Wrong copy.");
Index: test/heap_test.cc
===================================================================
--- test/heap_test.cc	(revision 927)
+++ test/heap_test.cc	(revision 921)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2011
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: test/lgf_test.cc
===================================================================
--- test/lgf_test.cc	(revision 935)
+++ test/lgf_test.cc	(revision 930)
@@ -64,8 +64,8 @@
 
 
-int main()
+int main() 
 {
   {
-    ListDigraph d;
+    ListDigraph d; 
     ListDigraph::Node s,t;
     ListDigraph::ArcMap<int> label(d);
@@ -94,5 +94,5 @@
 
   {
-    ListDigraph d;
+    ListDigraph d; 
     std::istringstream input(test_lgf_nomap);
     digraphReader(d, input).
@@ -111,5 +111,5 @@
 
   {
-    ListDigraph d;
+    ListDigraph d; 
     std::istringstream input(test_lgf_bad1);
     bool ok=false;
@@ -118,5 +118,5 @@
         run();
     }
-    catch (FormatError&)
+    catch (FormatError&) 
       {
         ok = true;
@@ -140,5 +140,5 @@
 
   {
-    ListDigraph d;
+    ListDigraph d; 
     std::istringstream input(test_lgf_bad2);
     bool ok=false;
Index: test/lp_test.cc
===================================================================
--- test/lp_test.cc	(revision 956)
+++ test/lp_test.cc	(revision 932)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2011
+ * Copyright (C) 2003-2009
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -42,35 +42,8 @@
 using namespace lemon;
 
-int countCols(LpBase & lp) {
-  int count=0;
-  for (LpBase::ColIt c(lp); c!=INVALID; ++c) ++count;
-  return count;
-}
-
-int countRows(LpBase & lp) {
-  int count=0;
-  for (LpBase::RowIt r(lp); r!=INVALID; ++r) ++count;
-  return count;
-}
-
-
 void lpTest(LpSolver& lp)
 {
 
   typedef LpSolver LP;
-
-  // Test LpBase::clear()
-  check(countRows(lp)==0, "Wrong number of rows");
-  check(countCols(lp)==0, "Wrong number of cols");
-  lp.addCol(); lp.addRow(); lp.addRow();
-  check(countRows(lp)==2, "Wrong number of rows");
-  check(countCols(lp)==1, "Wrong number of cols");
-  lp.clear();
-  check(countRows(lp)==0, "Wrong number of rows");
-  check(countCols(lp)==0, "Wrong number of cols");
-  lp.addCol(); lp.addCol(); lp.addCol(); lp.addRow();
-  check(countRows(lp)==1, "Wrong number of rows");
-  check(countCols(lp)==3, "Wrong number of cols");
-  lp.clear();
 
   std::vector<LP::Col> x(10);
Index: test/maps_test.cc
===================================================================
--- test/maps_test.cc	(revision 927)
+++ test/maps_test.cc	(revision 915)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2011
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
Index: test/path_test.cc
===================================================================
--- test/path_test.cc	(revision 957)
+++ test/path_test.cc	(revision 440)
@@ -39,35 +39,6 @@
 }
 
-// Check if proper copy consructor is called (use valgrind for testing)
-template<class _Path>
-void checkCopy()
-{
-  ListDigraph g;
-  ListDigraph::Arc a  = g.addArc(g.addNode(), g.addNode());
-  
-  _Path p,q;
-  p.addBack(a);
-  q=p;
-  _Path r(p);
-  StaticPath<ListDigraph> s(r);
-}
-  
 int main() {
   check_concepts();
-
-  checkCopy<Path<ListDigraph> >();
-  checkCopy<SimplePath<ListDigraph> >();
-  checkCopy<ListPath<ListDigraph> >();
-
-  ListDigraph g;
-  ListDigraph::Arc a  = g.addArc(g.addNode(), g.addNode());
-  
-  Path<ListDigraph> p;
-  StaticPath<ListDigraph> q,r;
-  p.addBack(a);
-  q=p;
-  r=q;
-  StaticPath<ListDigraph> s(q);
-
   return 0;
 }
Index: test/preflow_test.cc
===================================================================
--- test/preflow_test.cc	(revision 927)
+++ test/preflow_test.cc	(revision 902)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2011
+ * Copyright (C) 2003-2010
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -160,5 +160,5 @@
 {
   DIGRAPH_TYPEDEFS(SmartDigraph);
-
+  
   SmartDigraph g;
   SmartDigraph::ArcMap<int> cap(g),iflow(g);
@@ -272,5 +272,5 @@
 
   initFlowTest();
-
+  
   return 0;
 }