Index: src/lemon/bin_heap.h
===================================================================
--- src/lemon/bin_heap.h	(revision 921)
+++ src/lemon/bin_heap.h	(revision 967)
@@ -33,4 +33,9 @@
 
    /// A Binary Heap implementation.
+  
+  ///\todo Please document...
+  ///
+  ///\sa FibHeap
+  ///\sa Dijkstra
   template <typename Item, typename Prio, typename ItemIntMap,
 	    typename Compare = std::less<Prio> >
@@ -68,9 +73,13 @@
 
   public:
+    ///\e
     BinHeap(ItemIntMap &_iim) : iim(_iim) {}
+    ///\e
     BinHeap(ItemIntMap &_iim, const Compare &_comp) : comp(_comp), iim(_iim) {}
 
 
+    ///\e
     int size() const { return data.size(); }
+    ///\e
     bool empty() const { return data.empty(); }
 
@@ -102,4 +111,5 @@
 
   public:
+    ///\e
     void push(const PairType &p) {
       int n = data.size();
@@ -107,6 +117,8 @@
       bubble_up(n, p);
     }
+    ///\e
     void push(const Item &i, const Prio &p) { push(PairType(i,p)); }
 
+    ///\e
     Item top() const {
       return data[0].first;
@@ -117,12 +129,15 @@
     }
 
+    ///\e
     void pop() {
       rmidx(0);
     }
 
+    ///\e
     void erase(const Item &i) {
       rmidx(iim[i]);
     }
 
+    ///\e
     Prio operator[](const Item &i) const {
       int idx = iim[i];
@@ -130,4 +145,5 @@
     }
 
+    ///\e
     void set(const Item &i, const Prio &p) {
       int idx = iim[i];
@@ -143,8 +159,10 @@
     }
 
+    ///\e
     void decrease(const Item &i, const Prio &p) {
       int idx = iim[i];
       bubble_up(idx, PairType(i,p));
     }
+    ///\e
     void increase(const Item &i, const Prio &p) {
       int idx = iim[i];
@@ -152,4 +170,5 @@
     }
 
+    ///\e
     state_enum state(const Item &i) const {
       int s = iim[i];
Index: src/lemon/concept/path.h
===================================================================
--- src/lemon/concept/path.h	(revision 959)
+++ src/lemon/concept/path.h	(revision 967)
@@ -30,5 +30,5 @@
 
 
-    //! \brief A skeletom structure for representing directed paths in a graph.
+    //! \brief A skeleton structure for representing directed paths in a graph.
     //!
     //! A skeleton structure for representing directed paths in a graph.
Index: src/lemon/fib_heap.h
===================================================================
--- src/lemon/fib_heap.h	(revision 921)
+++ src/lemon/fib_heap.h	(revision 967)
@@ -50,4 +50,6 @@
   ///default is \c std::less<Prio>.
   ///
+  ///\sa BinHeap
+  ///\sa Dijkstra
   ///\author Jacint Szabo 
  
Index: src/lemon/graph_utils.h
===================================================================
--- src/lemon/graph_utils.h	(revision 964)
+++ src/lemon/graph_utils.h	(revision 967)
@@ -90,4 +90,34 @@
     }
     return num;
+  }
+
+  /// Finds an edge between two nodes of a graph.
+
+  /// Finds an edge from node \c u to node \c v in graph \c g.
+  ///
+  /// If \c prev is \ref INVALID (this is the default value), then
+  /// it finds the first edge from \c u to \c v. Otherwise it looks for
+  /// the next edge from \c u to \c v after \c prev.
+  /// \return The found edge or \ref INVALID if there is no such an edge.
+  ///
+  /// Thus you can iterate through each edge from \c u to \c v as it follows.
+  /// \code
+  /// for(Edge e=findEdge(g,u,v);e!=INVALID;e=findEdge(g,u,v,e)) {
+  ///   ...
+  /// }
+  /// \endcode
+  /// \todo We may want to use the \ref concept::GraphBase "GraphBase"
+  /// interface here...
+  /// \bug Untested ...
+  template <typename Graph>
+  typename Graph::Edge findEdge(const Graph &g,
+		typename Graph::Node u, typename Graph::Node v,
+		typename Graph::Edge prev = INVALID) 
+  {
+    typename Graph::OutEdgeIt e(g,prev);
+    if(prev==INVALID) g.first(e,u);
+    else ++e;
+    while(e!=INVALID && g.tail(e)!=v) ++e;
+    return e;
   }
   
Index: src/lemon/xy.h
===================================================================
--- src/lemon/xy.h	(revision 964)
+++ src/lemon/xy.h	(revision 967)
@@ -138,4 +138,5 @@
   ///Read a plainvector from a stream
 
+  ///Read a plainvector from a stream
   ///\relates xy
   ///
@@ -151,4 +152,5 @@
   ///Write a plainvector to a stream
 
+  ///Write a plainvector to a stream
   ///\relates xy
   ///
Index: src/work/alpar/dijkstra.h
===================================================================
--- src/work/alpar/dijkstra.h	(revision 959)
+++ src/work/alpar/dijkstra.h	(revision 967)
@@ -43,5 +43,5 @@
     ///The type of the map that stores the edge lengths.
 
-    ///It must meet the \ref ReadMap concept.
+    ///It must meet the \ref concept::ReadMap "ReadMap" concept.
     ///
     typedef LM LengthMap;
@@ -49,4 +49,9 @@
     typedef typename LM::ValueType ValueType;
     ///The heap type used by Dijkstra algorithm.
+
+    ///The heap type used by Dijkstra algorithm.
+    ///
+    ///\sa BinHeap
+    ///\sa Dijkstra
     typedef BinHeap<typename Graph::Node,
 		    typename LM::ValueType,
@@ -57,5 +62,5 @@
     ///edges of the shortest paths.
     /// 
-    ///It must meet the \ref WriteMap concept.
+    ///It must meet the \ref concept::WriteMap "WriteMap" concept.
     ///
     typedef typename Graph::template NodeMap<typename GR::Edge> PredMap;
@@ -71,5 +76,5 @@
     ///nodes of the shortest paths.
     ///
-    ///It must meet the \ref WriteMap concept.
+    ///It must meet the \ref concept::WriteMap "WriteMap" concept.
     ///
     typedef typename Graph::template NodeMap<typename GR::Node> PredNodeMap;
@@ -77,5 +82,5 @@
  
     ///\todo Please document...
-    /// 
+    ///
     static PredNodeMap *createPredNodeMap(const GR &G)
     {
@@ -84,5 +89,5 @@
     ///The type of the map that stores the dists of the nodes.
  
-    ///It must meet the \ref WriteMap concept.
+    ///It must meet the \ref concept::WriteMap "WriteMap" concept.
     ///
     typedef typename Graph::template NodeMap<typename LM::ValueType> DistMap;
@@ -167,5 +172,4 @@
     ///The heap type used by the dijkstra algorithm.
     typedef typename TR::Heap Heap;
-
   private:
     /// Pointer to the underlying graph.
@@ -225,4 +229,5 @@
     ///\ref named-templ-param "Named parameter" for setting PredMap type
 
+    ///\relates Dijkstra
     ///\ingroup flowalgs 
     ///\ref named-templ-param "Named parameter" for setting PredMap type